﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Infragistics.Web.UI.GridControls;
using System.Drawing;
using Infragistics.Web.UI;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        WebHierarchicalDataGrid1.DataSource = populateGrid();
        WebHierarchicalDataGrid1.DataBind();
    }

    protected void WebHierarchicalDataGrid1_RowIslandsPopulating(object sender, Infragistics.Web.UI.GridControls.ContainerRowCancelEventArgs e)
    {
        e.Cancel = true;

        switch (e.Row.Level)
        {
            case 0: BindSecondLevel(e);
                break;
            case 1: BindThirdLevel(e);
                break;
        }
    }

    private void BindSecondLevel(Infragistics.Web.UI.GridControls.ContainerRowCancelEventArgs e)
    {

        ContainerGrid grid = new ContainerGrid();
        grid.Level = 1;
        grid.AutoGenerateColumns = false;

        TemplateDataField col = new TemplateDataField();
        col.ItemTemplate = new ActionChildItemTemplate();
        col.Key = "TemplatedColumn";
        col.Header.Text = "Name";
        col.Hidden = true;
        grid.Columns.Add(col);

        BoundDataField col2 = new BoundDataField();
        col2.DataFieldName = "Name";
        col2.Key = "name";
        col2.Hidden = false;
        col2.Header.Text = "Name";
        grid.Columns.Add(col2);

        e.Row.RowIslands.Add(grid);

        grid.DataKeyFields = "Name";

        grid.DataSource = populateGrid() ;

        grid.Behaviors.Sorting.Enabled = true;
        grid.Behaviors.Paging.Enabled = true;
    }

    private void BindThirdLevel(Infragistics.Web.UI.GridControls.ContainerRowCancelEventArgs e)
    {
        ContainerGrid grid = new ContainerGrid();
        grid.Level = 2;
        grid.AutoGenerateColumns = false;

        TemplateDataField col = new TemplateDataField();
        col.ItemTemplate = new ActionChildItemTemplate();
        col.Key = "TemplatedColumn";
        col.Header.Text = "Name";
        col.Hidden = true;
        grid.Columns.Add(col);


        BoundDataField col2 = new BoundDataField();
        col2.DataFieldName = "Name";
        col2.Key = "name";
        col2.Hidden = false;
        col2.Header.Text = "Name";
        grid.Columns.Add(col2);

        e.Row.RowIslands.Add(grid);

        grid.DataKeyFields = "Name";
        grid.DataSource = childDS();
        grid.Behaviors.Sorting.Enabled = true;
        grid.Behaviors.Paging.Enabled = true;
    }

    protected void WebHierarchicalDataGrid1_RowIslandDataBinding(object sender, RowIslandEventArgs e)
    {
        
        if (e.RowIsland.Level == 1 || e.RowIsland.Level == 2)
        {
            e.RowIsland.DataSource = childDS();
        }
    }

    protected DataSet populateGrid()
    {
        DataTable dt = new DataTable();
        dt.Columns.Add("Name");
        DataRow row;
        for (int i = 0; i < 50; i++)
        {
            row = dt.NewRow();
            row.SetField<string>("Name", "Name" + i);
            dt.Rows.Add(row);
        }

        dt.PrimaryKey = new DataColumn[] { dt.Columns[0] };

        DataTable dt1 = new DataTable();
        dt1.Columns.Add("Name");

        for (int i = 0; i < 50; i++)
        {
            row = dt1.NewRow();
            row.SetField<string>("Name", "Name" + i);
            dt1.Rows.Add(row);
        }

        dt1.PrimaryKey = new DataColumn[] { dt1.Columns[0] };

        DataSet ds = new DataSet();
        ds.Tables.Add(dt);
        ds.Tables.Add(dt1);

        ds.Relations.Add(dt.Columns[0], dt1.Columns[0]);

        return ds;
    }


    protected DataTable childDS()
    {
        DataTable dt = new DataTable();
        dt.TableName = "child";
        dt.Columns.Add("Name");
        DataRow row;
        for (int i = 0; i < 10; i++)
        {
            row = dt.NewRow();
            row.SetField<string>("Name", "Name" + i);
            dt.Rows.Add(row);
        }

        return dt;
    }
    protected void WebHierarchicalDataGrid1_InitializeRow(object sender, RowEventArgs e)
    {
        if (((ContainerGridRecord)e.Row).Level < 2)
        {
            ((ContainerGridRecord)e.Row).IsEmptyParent = true;
        }
    }
}

public class ActionChildItemTemplate : ITemplate
{

    #region ITemplate Member

    public void InstantiateIn(Control container)
    {
        HyperLink link = new HyperLink();
        link.ID = "link";
        link.ForeColor = Color.Blue;
        link.Text = ((DataRowView)(((TemplateContainer)container).DataItem)).Row["Name"].ToString();
        container.Controls.Add(link);
    }

    #endregion

}
